/* message.c generated by valac 0.56.18, the Vala compiler
 * generated from message.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2025 Takao Fujiwara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <ibus.h>
#include <string.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdkwayland.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MESSAGE_DIALOG (message_dialog_get_type ())
#define MESSAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MESSAGE_DIALOG, MessageDialog))
#define MESSAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MESSAGE_DIALOG, MessageDialogClass))
#define IS_MESSAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MESSAGE_DIALOG))
#define IS_MESSAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MESSAGE_DIALOG))
#define MESSAGE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MESSAGE_DIALOG, MessageDialogClass))

typedef struct _MessageDialog MessageDialog;
typedef struct _MessageDialogClass MessageDialogClass;
typedef struct _MessageDialogPrivate MessageDialogPrivate;
enum  {
	MESSAGE_DIALOG_0_PROPERTY,
	MESSAGE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* message_dialog_properties[MESSAGE_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MESSAGE_DIALOG_CLOSE_SIGNAL,
	MESSAGE_DIALOG_REALIZE_SURFACE_SIGNAL,
	MESSAGE_DIALOG_NUM_SIGNALS
};
static guint message_dialog_signals[MESSAGE_DIALOG_NUM_SIGNALS] = {0};

struct _MessageDialog {
	GtkBox parent_instance;
	MessageDialogPrivate * priv;
};

struct _MessageDialogClass {
	GtkBoxClass parent_class;
};

struct _MessageDialogPrivate {
	GtkWindow* m_toplevel;
	GtkBox* m_vbox;
	GtkBox* m_hbox;
	GtkLabel* m_title_label;
	GtkLabel* m_description_label;
	GtkProgressBar* m_progress_bar;
	GtkLabel* m_progress_label;
	GtkLabel* m_timeout_label;
	GtkButton* m_button;
	gint m_timeout_time;
	gint m_elapsed_time;
	guint m_timeout_id;
	GdkRectangle m_cursor_location;
	gboolean m_is_wayland;
	gboolean m_no_wayland_panel;
	gboolean m_hide_after_show;
};

static gint MessageDialog_private_offset;
static gpointer message_dialog_parent_class = NULL;

VALA_EXTERN GType message_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MessageDialog, g_object_unref)
VALA_EXTERN MessageDialog* message_dialog_new (gboolean is_wayland,
                                   gboolean no_wayland_panel,
                                   IBusMessage* message);
VALA_EXTERN MessageDialog* message_dialog_construct (GType object_type,
                                         gboolean is_wayland,
                                         gboolean no_wayland_panel,
                                         IBusMessage* message);
static void __lambda67_ (MessageDialog* self,
                  GtkWidget* w,
                  GtkAllocation* a);
static void message_dialog_adjust_window_position (MessageDialog* self,
                                            GtkWidget* window);
static void ___lambda67__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static void ___lambda68_ (MessageDialog* self,
                   GtkWidget* w);
static void message_dialog_realize_window (MessageDialog* self,
                                    gboolean initial);
static void ____lambda68__gtk_widget_realize (GtkWidget* _sender,
                                       gpointer self);
static void ___lambda69_ (MessageDialog* self,
                   GtkWidget* w);
static void ____lambda69__gtk_widget_show (GtkWidget* _sender,
                                    gpointer self);
static void ___lambda70_ (MessageDialog* self,
                   GtkWidget* w);
static void ____lambda70__gtk_widget_hide (GtkWidget* _sender,
                                    gpointer self);
static void message_dialog_create_ui (MessageDialog* self,
                               IBusMessage* message);
VALA_EXTERN void message_dialog_set_cursor_location (MessageDialog* self,
                                         gint x,
                                         gint y,
                                         gint width,
                                         gint height);
static gboolean _cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                                     const cairo_rectangle_int_t * s2);
static void __lambda71_ (MessageDialog* self,
                  GtkButton* w);
static void ___lambda71__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static gboolean ___lambda72_ (MessageDialog* self);
static gboolean ____lambda72__gsource_func (gpointer self);
VALA_EXTERN void message_dialog_update_message (MessageDialog* self,
                                    IBusMessage* message);
VALA_EXTERN void message_dialog_show (MessageDialog* self);
VALA_EXTERN void message_dialog_hide (MessageDialog* self);
static void message_dialog_move (MessageDialog* self,
                          gint x,
                          gint y);
static void message_dialog_adjust_window_position_horizontal (MessageDialog* self,
                                                       GtkWidget* window);
static void message_dialog_get_monitor_geometry (MessageDialog* self,
                                          GtkWidget* window,
                                          GdkRectangle* result);
static void message_dialog_finalize (GObject * obj);
static GType message_dialog_get_type_once (void);

static inline gpointer
message_dialog_get_instance_private (MessageDialog* self)
{
	return G_STRUCT_MEMBER_P (self, MessageDialog_private_offset);
}

static void
__lambda67_ (MessageDialog* self,
             GtkWidget* w,
             GtkAllocation* a)
{
#line 66 "message.vala"
	g_return_if_fail (w != NULL);
#line 66 "message.vala"
	g_return_if_fail (a != NULL);
#line 67 "message.vala"
	message_dialog_adjust_window_position (self, w);
#line 192 "message.c"
}

static void
___lambda67__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 66 "message.vala"
	__lambda67_ ((MessageDialog*) self, _sender, allocation);
#line 202 "message.c"
}

static void
___lambda68_ (MessageDialog* self,
              GtkWidget* w)
{
#line 71 "message.vala"
	g_return_if_fail (w != NULL);
#line 72 "message.vala"
	message_dialog_realize_window (self, TRUE);
#line 213 "message.c"
}

static void
____lambda68__gtk_widget_realize (GtkWidget* _sender,
                                  gpointer self)
{
#line 71 "message.vala"
	___lambda68_ ((MessageDialog*) self, _sender);
#line 222 "message.c"
}

static void
___lambda69_ (MessageDialog* self,
              GtkWidget* w)
{
#line 74 "message.vala"
	g_return_if_fail (w != NULL);
#line 75 "message.vala"
	if (self->priv->m_hide_after_show) {
#line 76 "message.vala"
		message_dialog_realize_window (self, FALSE);
#line 235 "message.c"
	}
#line 77 "message.vala"
	self->priv->m_hide_after_show = FALSE;
#line 239 "message.c"
}

static void
____lambda69__gtk_widget_show (GtkWidget* _sender,
                               gpointer self)
{
#line 74 "message.vala"
	___lambda69_ ((MessageDialog*) self, _sender);
#line 248 "message.c"
}

static void
___lambda70_ (MessageDialog* self,
              GtkWidget* w)
{
#line 79 "message.vala"
	g_return_if_fail (w != NULL);
#line 80 "message.vala"
	self->priv->m_hide_after_show = TRUE;
#line 259 "message.c"
}

static void
____lambda70__gtk_widget_hide (GtkWidget* _sender,
                               gpointer self)
{
#line 79 "message.vala"
	___lambda70_ ((MessageDialog*) self, _sender);
#line 268 "message.c"
}

MessageDialog*
message_dialog_construct (GType object_type,
                          gboolean is_wayland,
                          gboolean no_wayland_panel,
                          IBusMessage* message)
{
	MessageDialog * self = NULL;
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkWindow* _tmp9_;
#line 52 "message.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 56 "message.vala"
	self = (MessageDialog*) g_object_new (object_type, "name", "IBusMessageDialog", "orientation", GTK_ORIENTATION_HORIZONTAL, "visible", TRUE, NULL);
#line 62 "message.vala"
	self->priv->m_is_wayland = is_wayland;
#line 63 "message.vala"
	self->priv->m_no_wayland_panel = no_wayland_panel;
#line 64 "message.vala"
	_tmp0_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_POPUP);
#line 64 "message.vala"
	g_object_ref_sink (_tmp0_);
#line 64 "message.vala"
	_g_object_unref0 (self->priv->m_toplevel);
#line 64 "message.vala"
	self->priv->m_toplevel = _tmp0_;
#line 65 "message.vala"
	_tmp1_ = self->priv->m_toplevel;
#line 65 "message.vala"
	gtk_widget_add_events ((GtkWidget*) _tmp1_, (gint) GDK_BUTTON_PRESS_MASK);
#line 66 "message.vala"
	_tmp2_ = self->priv->m_toplevel;
#line 66 "message.vala"
	g_signal_connect_object ((GtkWidget*) _tmp2_, "size-allocate", (GCallback) ___lambda67__gtk_widget_size_allocate, self, 0);
#line 70 "message.vala"
	if (self->priv->m_is_wayland) {
#line 311 "message.c"
		GtkWindow* _tmp3_;
		GtkWindow* _tmp4_;
		GtkWindow* _tmp5_;
#line 71 "message.vala"
		_tmp3_ = self->priv->m_toplevel;
#line 71 "message.vala"
		g_signal_connect_object ((GtkWidget*) _tmp3_, "realize", (GCallback) ____lambda68__gtk_widget_realize, self, 0);
#line 74 "message.vala"
		_tmp4_ = self->priv->m_toplevel;
#line 74 "message.vala"
		g_signal_connect_object ((GtkWidget*) _tmp4_, "show", (GCallback) ____lambda69__gtk_widget_show, self, 0);
#line 79 "message.vala"
		_tmp5_ = self->priv->m_toplevel;
#line 79 "message.vala"
		g_signal_connect_object ((GtkWidget*) _tmp5_, "hide", (GCallback) ____lambda70__gtk_widget_hide, self, 0);
#line 327 "message.c"
	}
#line 85 "message.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 85 "message.vala"
	g_object_ref_sink (_tmp6_);
#line 85 "message.vala"
	_g_object_unref0 (self->priv->m_vbox);
#line 85 "message.vala"
	self->priv->m_vbox = _tmp6_;
#line 86 "message.vala"
	_tmp7_ = self->priv->m_vbox;
#line 86 "message.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, TRUE);
#line 87 "message.vala"
	_tmp8_ = self->priv->m_vbox;
#line 87 "message.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp8_, FALSE, FALSE, (guint) 0);
#line 89 "message.vala"
	_tmp9_ = self->priv->m_toplevel;
#line 89 "message.vala"
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) self);
#line 91 "message.vala"
	message_dialog_create_ui (self, message);
#line 52 "message.vala"
	return self;
#line 353 "message.c"
}

MessageDialog*
message_dialog_new (gboolean is_wayland,
                    gboolean no_wayland_panel,
                    IBusMessage* message)
{
#line 52 "message.vala"
	return message_dialog_construct (TYPE_MESSAGE_DIALOG, is_wayland, no_wayland_panel, message);
#line 363 "message.c"
}

static gboolean
_cairo_rectangle_int_equal (const cairo_rectangle_int_t * s1,
                            const cairo_rectangle_int_t * s2)
{
#line 97 "message.vala"
	if (s1 == s2) {
#line 97 "message.vala"
		return TRUE;
#line 374 "message.c"
	}
#line 97 "message.vala"
	if (s1 == NULL) {
#line 97 "message.vala"
		return FALSE;
#line 380 "message.c"
	}
#line 97 "message.vala"
	if (s2 == NULL) {
#line 97 "message.vala"
		return FALSE;
#line 386 "message.c"
	}
#line 97 "message.vala"
	if (s1->x != s2->x) {
#line 97 "message.vala"
		return FALSE;
#line 392 "message.c"
	}
#line 97 "message.vala"
	if (s1->y != s2->y) {
#line 97 "message.vala"
		return FALSE;
#line 398 "message.c"
	}
#line 97 "message.vala"
	if (s1->width != s2->width) {
#line 97 "message.vala"
		return FALSE;
#line 404 "message.c"
	}
#line 97 "message.vala"
	if (s1->height != s2->height) {
#line 97 "message.vala"
		return FALSE;
#line 410 "message.c"
	}
#line 97 "message.vala"
	return TRUE;
#line 414 "message.c"
}

void
message_dialog_set_cursor_location (MessageDialog* self,
                                    gint x,
                                    gint y,
                                    gint width,
                                    gint height)
{
	GdkRectangle location = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
#line 94 "message.vala"
	g_return_if_fail (self != NULL);
#line 95 "message.vala"
	memset (&_tmp0_, 0, sizeof (GdkRectangle));
#line 95 "message.vala"
	_tmp0_.x = x;
#line 95 "message.vala"
	_tmp0_.y = y;
#line 95 "message.vala"
	_tmp0_.width = width;
#line 95 "message.vala"
	_tmp0_.height = height;
#line 95 "message.vala"
	location = _tmp0_;
#line 97 "message.vala"
	_tmp1_ = self->priv->m_cursor_location;
#line 97 "message.vala"
	_tmp2_ = location;
#line 97 "message.vala"
	if (_cairo_rectangle_int_equal (&_tmp1_, &_tmp2_) == TRUE) {
#line 98 "message.vala"
		return;
#line 451 "message.c"
	}
#line 99 "message.vala"
	_tmp3_ = location;
#line 99 "message.vala"
	self->priv->m_cursor_location = _tmp3_;
#line 457 "message.c"
}

static void
__lambda71_ (MessageDialog* self,
             GtkButton* w)
{
#line 177 "message.vala"
	g_return_if_fail (w != NULL);
#line 178 "message.vala"
	if (self->priv->m_timeout_id > ((guint) 0)) {
#line 179 "message.vala"
		g_source_remove (self->priv->m_timeout_id);
#line 180 "message.vala"
		self->priv->m_timeout_id = (guint) 0;
#line 472 "message.c"
	}
#line 182 "message.vala"
	g_signal_emit (self, message_dialog_signals[MESSAGE_DIALOG_CLOSE_SIGNAL], 0);
#line 476 "message.c"
}

static void
___lambda71__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 177 "message.vala"
	__lambda71_ ((MessageDialog*) self, _sender);
#line 485 "message.c"
}

static gboolean
___lambda72_ (MessageDialog* self)
{
	GtkLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean result;
#line 188 "message.vala"
	if (self->priv->m_elapsed_time >= self->priv->m_timeout_time) {
#line 189 "message.vala"
		g_signal_emit (self, message_dialog_signals[MESSAGE_DIALOG_CLOSE_SIGNAL], 0);
#line 190 "message.vala"
		self->priv->m_timeout_id = (guint) 0;
#line 191 "message.vala"
		result = G_SOURCE_REMOVE;
#line 191 "message.vala"
		return result;
#line 507 "message.c"
	}
#line 193 "message.vala"
	_tmp0_ = self->priv->m_timeout_label;
#line 193 "message.vala"
	_tmp1_ = self->priv->m_timeout_time;
#line 193 "message.vala"
	_tmp2_ = self->priv->m_elapsed_time;
#line 193 "message.vala"
	self->priv->m_elapsed_time = _tmp2_ + 1;
#line 193 "message.vala"
	_tmp3_ = g_strdup_printf (_ ("%5dSec"), _tmp1_ - _tmp2_);
#line 193 "message.vala"
	_tmp4_ = _tmp3_;
#line 193 "message.vala"
	gtk_label_set_text (_tmp0_, _tmp4_);
#line 193 "message.vala"
	_g_free0 (_tmp4_);
#line 195 "message.vala"
	result = G_SOURCE_CONTINUE;
#line 195 "message.vala"
	return result;
#line 529 "message.c"
}

static gboolean
____lambda72__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda72_ ((MessageDialog*) self);
#line 186 "message.vala"
	return result;
#line 539 "message.c"
}

static void
message_dialog_create_ui (MessageDialog* self,
                          IBusMessage* message)
{
	gchar* title = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* description = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	const gchar* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkBox* _tmp25_;
	GtkBox* _tmp26_;
	GtkBox* _tmp27_;
	GtkProgressBar* _tmp28_;
	GtkProgressBar* _tmp29_;
	GtkProgressBar* _tmp30_;
	GtkProgressBar* _tmp31_;
	GtkLabel* _tmp32_;
	gint progress = 0;
	gdouble progress_f = 0.0;
	gboolean _tmp33_ = FALSE;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	gboolean _tmp52_ = FALSE;
	GtkButton* _tmp59_;
	GtkButton* _tmp60_;
	GtkButton* _tmp61_;
	GtkBox* _tmp62_;
	GtkLabel* _tmp63_;
	GtkBox* _tmp64_;
	GtkLabel* _tmp65_;
	GtkBox* _tmp66_;
	GtkBox* _tmp67_;
	GtkBox* _tmp68_;
	GtkProgressBar* _tmp69_;
	GtkBox* _tmp70_;
	GtkLabel* _tmp71_;
	GtkBox* _tmp72_;
	GtkLabel* _tmp73_;
	GtkBox* _tmp74_;
	GtkButton* _tmp75_;
	GtkWindow* _tmp76_;
#line 106 "message.vala"
	g_return_if_fail (self != NULL);
#line 106 "message.vala"
	g_return_if_fail (message != NULL);
#line 107 "message.vala"
	_tmp0_ = ibus_message_get_title (message);
#line 107 "message.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 107 "message.vala"
	title = _tmp1_;
#line 108 "message.vala"
	_tmp2_ = ibus_message_get_description (message);
#line 108 "message.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 108 "message.vala"
	description = _tmp3_;
#line 110 "message.vala"
	_tmp4_ = title;
#line 110 "message.vala"
	_tmp5_ = strlen (_tmp4_);
#line 110 "message.vala"
	_tmp6_ = _tmp5_;
#line 110 "message.vala"
	if (_tmp6_ > 0) {
#line 628 "message.c"
		const gchar* _tmp7_;
		GtkLabel* _tmp8_;
#line 111 "message.vala"
		_tmp7_ = title;
#line 111 "message.vala"
		_tmp8_ = (GtkLabel*) gtk_label_new (_tmp7_);
#line 111 "message.vala"
		g_object_ref_sink (_tmp8_);
#line 111 "message.vala"
		_g_object_unref0 (self->priv->m_title_label);
#line 111 "message.vala"
		self->priv->m_title_label = _tmp8_;
#line 641 "message.c"
	} else {
		GtkLabel* _tmp9_;
		GtkLabel* _tmp10_;
#line 113 "message.vala"
		_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 113 "message.vala"
		g_object_ref_sink (_tmp9_);
#line 113 "message.vala"
		_g_object_unref0 (self->priv->m_title_label);
#line 113 "message.vala"
		self->priv->m_title_label = _tmp9_;
#line 114 "message.vala"
		_tmp10_ = self->priv->m_title_label;
#line 114 "message.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
#line 657 "message.c"
	}
#line 116 "message.vala"
	_tmp11_ = self->priv->m_title_label;
#line 116 "message.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_CENTER);
#line 117 "message.vala"
	_tmp12_ = self->priv->m_title_label;
#line 117 "message.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_CENTER);
#line 118 "message.vala"
	_tmp13_ = self->priv->m_title_label;
#line 118 "message.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp13_, 8);
#line 119 "message.vala"
	_tmp14_ = self->priv->m_title_label;
#line 119 "message.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp14_, 8);
#line 120 "message.vala"
	_tmp15_ = self->priv->m_title_label;
#line 120 "message.vala"
	gtk_label_set_line_wrap (_tmp15_, TRUE);
#line 121 "message.vala"
	_tmp16_ = self->priv->m_title_label;
#line 121 "message.vala"
	gtk_label_set_width_chars (_tmp16_, 50);
#line 123 "message.vala"
	_tmp17_ = description;
#line 123 "message.vala"
	_tmp18_ = (GtkLabel*) gtk_label_new (_tmp17_);
#line 123 "message.vala"
	g_object_ref_sink (_tmp18_);
#line 123 "message.vala"
	_g_object_unref0 (self->priv->m_description_label);
#line 123 "message.vala"
	self->priv->m_description_label = _tmp18_;
#line 124 "message.vala"
	_tmp19_ = self->priv->m_description_label;
#line 124 "message.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_START);
#line 125 "message.vala"
	_tmp20_ = self->priv->m_description_label;
#line 125 "message.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp20_, GTK_ALIGN_CENTER);
#line 126 "message.vala"
	_tmp21_ = self->priv->m_description_label;
#line 126 "message.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp21_, 8);
#line 127 "message.vala"
	_tmp22_ = self->priv->m_description_label;
#line 127 "message.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp22_, 8);
#line 128 "message.vala"
	_tmp23_ = self->priv->m_description_label;
#line 128 "message.vala"
	gtk_label_set_line_wrap (_tmp23_, TRUE);
#line 129 "message.vala"
	_tmp24_ = self->priv->m_description_label;
#line 129 "message.vala"
	gtk_label_set_width_chars (_tmp24_, 50);
#line 131 "message.vala"
	_tmp25_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 5);
#line 131 "message.vala"
	g_object_ref_sink (_tmp25_);
#line 131 "message.vala"
	_g_object_unref0 (self->priv->m_hbox);
#line 131 "message.vala"
	self->priv->m_hbox = _tmp25_;
#line 132 "message.vala"
	_tmp26_ = self->priv->m_hbox;
#line 132 "message.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp26_, GTK_ALIGN_CENTER);
#line 133 "message.vala"
	_tmp27_ = self->priv->m_hbox;
#line 133 "message.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp27_, GTK_ALIGN_CENTER);
#line 134 "message.vala"
	_tmp28_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 134 "message.vala"
	g_object_ref_sink (_tmp28_);
#line 134 "message.vala"
	_g_object_unref0 (self->priv->m_progress_bar);
#line 134 "message.vala"
	self->priv->m_progress_bar = _tmp28_;
#line 135 "message.vala"
	_tmp29_ = self->priv->m_progress_bar;
#line 135 "message.vala"
	gtk_progress_bar_set_ellipsize (_tmp29_, PANGO_ELLIPSIZE_MIDDLE);
#line 136 "message.vala"
	_tmp30_ = self->priv->m_progress_bar;
#line 136 "message.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp30_, GTK_ALIGN_CENTER);
#line 137 "message.vala"
	_tmp31_ = self->priv->m_progress_bar;
#line 137 "message.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp31_, GTK_ALIGN_CENTER);
#line 138 "message.vala"
	_tmp32_ = (GtkLabel*) gtk_label_new (NULL);
#line 138 "message.vala"
	g_object_ref_sink (_tmp32_);
#line 138 "message.vala"
	_g_object_unref0 (self->priv->m_progress_label);
#line 138 "message.vala"
	self->priv->m_progress_label = _tmp32_;
#line 140 "message.vala"
	progress = ibus_message_get_progress (message);
#line 141 "message.vala"
	progress_f = progress / 100.0;
#line 142 "message.vala"
	if (progress_f <= 1.0) {
#line 142 "message.vala"
		_tmp33_ = progress >= 0;
#line 769 "message.c"
	} else {
#line 142 "message.vala"
		_tmp33_ = FALSE;
#line 773 "message.c"
	}
#line 142 "message.vala"
	if (_tmp33_) {
#line 777 "message.c"
		GtkProgressBar* _tmp34_;
		GtkProgressBar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		GtkLabel* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
#line 143 "message.vala"
		_tmp34_ = self->priv->m_progress_bar;
#line 143 "message.vala"
		gtk_progress_bar_set_fraction (_tmp34_, progress_f);
#line 144 "message.vala"
		_tmp35_ = self->priv->m_progress_bar;
#line 144 "message.vala"
		_tmp36_ = g_strdup_printf ("%2u%%\n", (guint) progress);
#line 144 "message.vala"
		_tmp37_ = _tmp36_;
#line 144 "message.vala"
		gtk_progress_bar_set_text (_tmp35_, _tmp37_);
#line 144 "message.vala"
		_g_free0 (_tmp37_);
#line 146 "message.vala"
		_tmp38_ = self->priv->m_progress_label;
#line 146 "message.vala"
		_tmp39_ = g_strdup_printf ("%2u%%\n", (guint) progress);
#line 146 "message.vala"
		_tmp40_ = _tmp39_;
#line 146 "message.vala"
		gtk_label_set_text (_tmp38_, _tmp40_);
#line 146 "message.vala"
		_g_free0 (_tmp40_);
#line 809 "message.c"
	} else {
		GtkBox* _tmp41_;
#line 149 "message.vala"
		if (progress_f > 1.0) {
#line 150 "message.vala"
			g_warning ("message.vala:150: Progress should be below 100.");
#line 816 "message.c"
		}
#line 151 "message.vala"
		_tmp41_ = self->priv->m_hbox;
#line 151 "message.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp41_, TRUE);
#line 822 "message.c"
	}
#line 154 "message.vala"
	self->priv->m_timeout_time = ibus_message_get_timeout (message);
#line 155 "message.vala"
	if (self->priv->m_timeout_time >= 0) {
#line 828 "message.c"
		gchar* _tmp42_;
		gchar* _tmp43_;
		GtkLabel* _tmp44_;
#line 156 "message.vala"
		_tmp42_ = g_strdup_printf (_ ("%5dSec"), self->priv->m_timeout_time);
#line 156 "message.vala"
		_tmp43_ = _tmp42_;
#line 156 "message.vala"
		_tmp44_ = (GtkLabel*) gtk_label_new (_tmp43_);
#line 156 "message.vala"
		g_object_ref_sink (_tmp44_);
#line 156 "message.vala"
		_g_object_unref0 (self->priv->m_timeout_label);
#line 156 "message.vala"
		self->priv->m_timeout_label = _tmp44_;
#line 156 "message.vala"
		_g_free0 (_tmp43_);
#line 846 "message.c"
	} else {
		GtkLabel* _tmp45_;
		GtkLabel* _tmp46_;
#line 158 "message.vala"
		_tmp45_ = (GtkLabel*) gtk_label_new (NULL);
#line 158 "message.vala"
		g_object_ref_sink (_tmp45_);
#line 158 "message.vala"
		_g_object_unref0 (self->priv->m_timeout_label);
#line 158 "message.vala"
		self->priv->m_timeout_label = _tmp45_;
#line 159 "message.vala"
		_tmp46_ = self->priv->m_timeout_label;
#line 159 "message.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp46_, TRUE);
#line 862 "message.c"
	}
#line 161 "message.vala"
	_tmp47_ = self->priv->m_timeout_label;
#line 161 "message.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp47_, 20, -1);
#line 162 "message.vala"
	_tmp48_ = self->priv->m_timeout_label;
#line 162 "message.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp48_, GTK_ALIGN_CENTER);
#line 163 "message.vala"
	_tmp49_ = self->priv->m_timeout_label;
#line 163 "message.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp49_, GTK_ALIGN_CENTER);
#line 164 "message.vala"
	_tmp50_ = self->priv->m_timeout_label;
#line 164 "message.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp50_, 8);
#line 165 "message.vala"
	_tmp51_ = self->priv->m_timeout_label;
#line 165 "message.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp51_, 8);
#line 167 "message.vala"
	if (ibus_message_get_serial (message) > ((guint) 0)) {
#line 167 "message.vala"
		_tmp52_ = self->priv->m_timeout_time >= 0;
#line 888 "message.c"
	} else {
#line 167 "message.vala"
		_tmp52_ = FALSE;
#line 892 "message.c"
	}
#line 167 "message.vala"
	if (_tmp52_) {
#line 896 "message.c"
		GtkButton* _tmp53_;
		GtkButton* _tmp54_;
#line 168 "message.vala"
		_tmp53_ = (GtkButton*) gtk_button_new ();
#line 168 "message.vala"
		g_object_ref_sink (_tmp53_);
#line 168 "message.vala"
		_g_object_unref0 (self->priv->m_button);
#line 168 "message.vala"
		self->priv->m_button = _tmp53_;
#line 169 "message.vala"
		_tmp54_ = self->priv->m_button;
#line 169 "message.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp54_, TRUE);
#line 911 "message.c"
	} else {
		GtkButton* _tmp55_;
		GtkButton* _tmp56_;
		GtkStyleContext* _tmp57_;
		GtkButton* _tmp58_;
#line 171 "message.vala"
		_tmp55_ = (GtkButton*) gtk_button_new_with_label (_ ("Close"));
#line 171 "message.vala"
		g_object_ref_sink (_tmp55_);
#line 171 "message.vala"
		_g_object_unref0 (self->priv->m_button);
#line 171 "message.vala"
		self->priv->m_button = _tmp55_;
#line 172 "message.vala"
		_tmp56_ = self->priv->m_button;
#line 172 "message.vala"
		_tmp57_ = gtk_widget_get_style_context ((GtkWidget*) _tmp56_);
#line 172 "message.vala"
		gtk_style_context_add_class (_tmp57_, "text-button");
#line 173 "message.vala"
		_tmp58_ = self->priv->m_button;
#line 173 "message.vala"
		gtk_widget_set_can_default ((GtkWidget*) _tmp58_, TRUE);
#line 935 "message.c"
	}
#line 175 "message.vala"
	_tmp59_ = self->priv->m_button;
#line 175 "message.vala"
	gtk_button_set_use_underline (_tmp59_, TRUE);
#line 176 "message.vala"
	_tmp60_ = self->priv->m_button;
#line 176 "message.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp60_, GTK_ALIGN_BASELINE);
#line 177 "message.vala"
	_tmp61_ = self->priv->m_button;
#line 177 "message.vala"
	g_signal_connect_object (_tmp61_, "clicked", (GCallback) ___lambda71__gtk_button_clicked, self, 0);
#line 184 "message.vala"
	if (self->priv->m_timeout_time >= 0) {
#line 185 "message.vala"
		self->priv->m_elapsed_time = 1;
#line 186 "message.vala"
		self->priv->m_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda72__gsource_func, g_object_ref (self), g_object_unref);
#line 955 "message.c"
	}
#line 199 "message.vala"
	_tmp62_ = self->priv->m_vbox;
#line 199 "message.vala"
	_tmp63_ = self->priv->m_title_label;
#line 199 "message.vala"
	gtk_box_pack_start (_tmp62_, (GtkWidget*) _tmp63_, FALSE, FALSE, (guint) 4);
#line 200 "message.vala"
	_tmp64_ = self->priv->m_vbox;
#line 200 "message.vala"
	_tmp65_ = self->priv->m_description_label;
#line 200 "message.vala"
	gtk_box_pack_start (_tmp64_, (GtkWidget*) _tmp65_, FALSE, FALSE, (guint) 4);
#line 201 "message.vala"
	_tmp66_ = self->priv->m_vbox;
#line 201 "message.vala"
	_tmp67_ = self->priv->m_hbox;
#line 201 "message.vala"
	gtk_container_add ((GtkContainer*) _tmp66_, (GtkWidget*) _tmp67_);
#line 202 "message.vala"
	_tmp68_ = self->priv->m_hbox;
#line 202 "message.vala"
	_tmp69_ = self->priv->m_progress_bar;
#line 202 "message.vala"
	gtk_container_add ((GtkContainer*) _tmp68_, (GtkWidget*) _tmp69_);
#line 203 "message.vala"
	_tmp70_ = self->priv->m_hbox;
#line 203 "message.vala"
	_tmp71_ = self->priv->m_progress_label;
#line 203 "message.vala"
	gtk_container_add ((GtkContainer*) _tmp70_, (GtkWidget*) _tmp71_);
#line 204 "message.vala"
	_tmp72_ = self->priv->m_vbox;
#line 204 "message.vala"
	_tmp73_ = self->priv->m_timeout_label;
#line 204 "message.vala"
	gtk_box_pack_start (_tmp72_, (GtkWidget*) _tmp73_, FALSE, FALSE, (guint) 4);
#line 205 "message.vala"
	_tmp74_ = self->priv->m_vbox;
#line 205 "message.vala"
	_tmp75_ = self->priv->m_button;
#line 205 "message.vala"
	gtk_box_pack_start (_tmp74_, (GtkWidget*) _tmp75_, FALSE, FALSE, (guint) 0);
#line 207 "message.vala"
	_tmp76_ = self->priv->m_toplevel;
#line 207 "message.vala"
	gtk_window_resize (_tmp76_, 1, 1);
#line 106 "message.vala"
	_g_free0 (description);
#line 106 "message.vala"
	_g_free0 (title);
#line 1007 "message.c"
}

void
message_dialog_update_message (MessageDialog* self,
                               IBusMessage* message)
{
	gchar* title = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* description = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GtkLabel* _tmp11_;
	const gchar* _tmp12_;
	gint progress = 0;
	gdouble progress_f = 0.0;
	gboolean _tmp18_ = FALSE;
	GtkWindow* _tmp28_;
#line 210 "message.vala"
	g_return_if_fail (self != NULL);
#line 210 "message.vala"
	g_return_if_fail (message != NULL);
#line 211 "message.vala"
	_tmp0_ = ibus_message_get_title (message);
#line 211 "message.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 211 "message.vala"
	title = _tmp1_;
#line 212 "message.vala"
	_tmp2_ = ibus_message_get_description (message);
#line 212 "message.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 212 "message.vala"
	description = _tmp3_;
#line 214 "message.vala"
	_tmp4_ = title;
#line 214 "message.vala"
	_tmp5_ = strlen (_tmp4_);
#line 214 "message.vala"
	_tmp6_ = _tmp5_;
#line 214 "message.vala"
	if (_tmp6_ > 0) {
#line 1053 "message.c"
		GtkLabel* _tmp7_;
		const gchar* _tmp8_;
		GtkLabel* _tmp9_;
#line 215 "message.vala"
		_tmp7_ = self->priv->m_title_label;
#line 215 "message.vala"
		_tmp8_ = title;
#line 215 "message.vala"
		gtk_label_set_text (_tmp7_, _tmp8_);
#line 216 "message.vala"
		_tmp9_ = self->priv->m_title_label;
#line 216 "message.vala"
		gtk_widget_show ((GtkWidget*) _tmp9_);
#line 1067 "message.c"
	} else {
		GtkLabel* _tmp10_;
#line 218 "message.vala"
		_tmp10_ = self->priv->m_title_label;
#line 218 "message.vala"
		gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 1074 "message.c"
	}
#line 220 "message.vala"
	_tmp11_ = self->priv->m_description_label;
#line 220 "message.vala"
	_tmp12_ = description;
#line 220 "message.vala"
	gtk_label_set_text (_tmp11_, _tmp12_);
#line 222 "message.vala"
	self->priv->m_timeout_time = ibus_message_get_timeout (message);
#line 223 "message.vala"
	if (self->priv->m_timeout_time >= 0) {
#line 1086 "message.c"
		GtkLabel* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GtkLabel* _tmp16_;
#line 224 "message.vala"
		_tmp13_ = self->priv->m_timeout_label;
#line 224 "message.vala"
		_tmp14_ = g_strdup_printf (_ ("%5dSec"), self->priv->m_timeout_time);
#line 224 "message.vala"
		_tmp15_ = _tmp14_;
#line 224 "message.vala"
		gtk_label_set_text (_tmp13_, _tmp15_);
#line 224 "message.vala"
		_g_free0 (_tmp15_);
#line 225 "message.vala"
		_tmp16_ = self->priv->m_timeout_label;
#line 225 "message.vala"
		gtk_widget_show ((GtkWidget*) _tmp16_);
#line 226 "message.vala"
		self->priv->m_elapsed_time = 1;
#line 1107 "message.c"
	} else {
		GtkLabel* _tmp17_;
#line 228 "message.vala"
		_tmp17_ = self->priv->m_timeout_label;
#line 228 "message.vala"
		gtk_widget_hide ((GtkWidget*) _tmp17_);
#line 1114 "message.c"
	}
#line 231 "message.vala"
	progress = ibus_message_get_progress (message);
#line 232 "message.vala"
	progress_f = progress / 100.0;
#line 233 "message.vala"
	if (progress_f <= 1.0) {
#line 233 "message.vala"
		_tmp18_ = progress >= 0;
#line 1124 "message.c"
	} else {
#line 233 "message.vala"
		_tmp18_ = FALSE;
#line 1128 "message.c"
	}
#line 233 "message.vala"
	if (_tmp18_) {
#line 1132 "message.c"
		GtkProgressBar* _tmp19_;
		GtkProgressBar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GtkLabel* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GtkBox* _tmp26_;
#line 234 "message.vala"
		_tmp19_ = self->priv->m_progress_bar;
#line 234 "message.vala"
		gtk_progress_bar_set_fraction (_tmp19_, progress_f);
#line 235 "message.vala"
		_tmp20_ = self->priv->m_progress_bar;
#line 235 "message.vala"
		_tmp21_ = g_strdup_printf ("%2u%%\n", (guint) progress);
#line 235 "message.vala"
		_tmp22_ = _tmp21_;
#line 235 "message.vala"
		gtk_progress_bar_set_text (_tmp20_, _tmp22_);
#line 235 "message.vala"
		_g_free0 (_tmp22_);
#line 237 "message.vala"
		_tmp23_ = self->priv->m_progress_label;
#line 237 "message.vala"
		_tmp24_ = g_strdup_printf ("%2u%%\n", (guint) progress);
#line 237 "message.vala"
		_tmp25_ = _tmp24_;
#line 237 "message.vala"
		gtk_label_set_text (_tmp23_, _tmp25_);
#line 237 "message.vala"
		_g_free0 (_tmp25_);
#line 239 "message.vala"
		_tmp26_ = self->priv->m_hbox;
#line 239 "message.vala"
		gtk_widget_show ((GtkWidget*) _tmp26_);
#line 1169 "message.c"
	} else {
		GtkBox* _tmp27_;
#line 241 "message.vala"
		if (progress_f > 1.0) {
#line 242 "message.vala"
			g_warning ("message.vala:242: Progress should be below 100.");
#line 1176 "message.c"
		}
#line 243 "message.vala"
		_tmp27_ = self->priv->m_hbox;
#line 243 "message.vala"
		gtk_widget_hide ((GtkWidget*) _tmp27_);
#line 1182 "message.c"
	}
#line 246 "message.vala"
	_tmp28_ = self->priv->m_toplevel;
#line 246 "message.vala"
	gtk_window_resize (_tmp28_, 1, 1);
#line 247 "message.vala"
	message_dialog_show (self);
#line 210 "message.vala"
	_g_free0 (description);
#line 210 "message.vala"
	_g_free0 (title);
#line 1194 "message.c"
}

void
message_dialog_show (MessageDialog* self)
{
	GtkWindow* _tmp0_;
#line 250 "message.vala"
	g_return_if_fail (self != NULL);
#line 251 "message.vala"
	_tmp0_ = self->priv->m_toplevel;
#line 251 "message.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
#line 1207 "message.c"
}

void
message_dialog_hide (MessageDialog* self)
{
	GtkWindow* _tmp0_;
#line 254 "message.vala"
	g_return_if_fail (self != NULL);
#line 256 "message.vala"
	if (self->priv->m_is_wayland) {
#line 257 "message.vala"
		g_signal_emit (self, message_dialog_signals[MESSAGE_DIALOG_REALIZE_SURFACE_SIGNAL], 0, NULL);
#line 1220 "message.c"
	}
#line 259 "message.vala"
	_tmp0_ = self->priv->m_toplevel;
#line 259 "message.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 1226 "message.c"
}

/**
     * move:
     * @x: left position of the #MessageDialog
     * @y: top position of the #MessageDialog
     */
static void
message_dialog_move (MessageDialog* self,
                     gint x,
                     gint y)
{
	GtkWindow* _tmp0_;
#line 267 "message.vala"
	g_return_if_fail (self != NULL);
#line 268 "message.vala"
	_tmp0_ = self->priv->m_toplevel;
#line 268 "message.vala"
	gtk_window_move (_tmp0_, x, y);
#line 1246 "message.c"
}

static void
message_dialog_adjust_window_position (MessageDialog* self,
                                       GtkWidget* window)
{
#line 271 "message.vala"
	g_return_if_fail (self != NULL);
#line 271 "message.vala"
	g_return_if_fail (window != NULL);
#line 272 "message.vala"
	message_dialog_adjust_window_position_horizontal (self, window);
#line 1259 "message.c"
}

/**
     * adjust_window_position_horizontal:
     * @window: A Gtk.Widget of the toplevel window.
     *
     * Horizontal writing mode but not the horizontal lookup table
     * when the allocation is emmitted.
     */
static void
message_dialog_adjust_window_position_horizontal (MessageDialog* self,
                                                  GtkWidget* window)
{
	GdkPoint cursor_left_bottom = {0};
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkPoint _tmp3_ = {0};
	GtkAllocation allocation = {0};
	GtkWindow* _tmp4_;
	GtkAllocation _tmp5_ = {0};
	GdkPoint window_right_bottom = {0};
	GdkPoint _tmp6_;
	GtkAllocation _tmp7_;
	GdkPoint _tmp8_;
	GtkAllocation _tmp9_;
	GdkPoint _tmp10_ = {0};
	GdkRectangle monitor_area = {0};
	GdkRectangle _tmp11_ = {0};
	gint monitor_right = 0;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp13_;
	gint monitor_bottom = 0;
	GdkRectangle _tmp14_;
	GdkRectangle _tmp15_;
	gint x = 0;
	gint y = 0;
	GdkPoint _tmp16_;
	GdkPoint _tmp19_;
#line 282 "message.vala"
	g_return_if_fail (self != NULL);
#line 282 "message.vala"
	g_return_if_fail (window != NULL);
#line 283 "message.vala"
	_tmp0_ = self->priv->m_cursor_location;
#line 283 "message.vala"
	_tmp1_ = self->priv->m_cursor_location;
#line 283 "message.vala"
	_tmp2_ = self->priv->m_cursor_location;
#line 283 "message.vala"
	_tmp3_.x = _tmp0_.x;
#line 283 "message.vala"
	_tmp3_.y = _tmp1_.y + _tmp2_.height;
#line 283 "message.vala"
	cursor_left_bottom = _tmp3_;
#line 289 "message.vala"
	_tmp4_ = self->priv->m_toplevel;
#line 289 "message.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp4_, &_tmp5_);
#line 289 "message.vala"
	allocation = _tmp5_;
#line 290 "message.vala"
	_tmp6_ = cursor_left_bottom;
#line 290 "message.vala"
	_tmp7_ = allocation;
#line 290 "message.vala"
	_tmp8_ = cursor_left_bottom;
#line 290 "message.vala"
	_tmp9_ = allocation;
#line 290 "message.vala"
	_tmp10_.x = _tmp6_.x + _tmp7_.width;
#line 290 "message.vala"
	_tmp10_.y = _tmp8_.y + _tmp9_.height;
#line 290 "message.vala"
	window_right_bottom = _tmp10_;
#line 295 "message.vala"
	message_dialog_get_monitor_geometry (self, window, &_tmp11_);
#line 295 "message.vala"
	monitor_area = _tmp11_;
#line 296 "message.vala"
	_tmp12_ = monitor_area;
#line 296 "message.vala"
	_tmp13_ = monitor_area;
#line 296 "message.vala"
	monitor_right = _tmp12_.x + _tmp13_.width;
#line 297 "message.vala"
	_tmp14_ = monitor_area;
#line 297 "message.vala"
	_tmp15_ = monitor_area;
#line 297 "message.vala"
	monitor_bottom = _tmp14_.y + _tmp15_.height;
#line 300 "message.vala"
	_tmp16_ = window_right_bottom;
#line 300 "message.vala"
	if (_tmp16_.x > monitor_right) {
#line 1355 "message.c"
		GtkAllocation _tmp17_;
#line 301 "message.vala"
		_tmp17_ = allocation;
#line 301 "message.vala"
		x = monitor_right - _tmp17_.width;
#line 1361 "message.c"
	} else {
		GdkPoint _tmp18_;
#line 303 "message.vala"
		_tmp18_ = cursor_left_bottom;
#line 303 "message.vala"
		x = _tmp18_.x;
#line 1368 "message.c"
	}
#line 304 "message.vala"
	if (x < 0) {
#line 305 "message.vala"
		x = 0;
#line 1374 "message.c"
	}
#line 307 "message.vala"
	_tmp19_ = window_right_bottom;
#line 307 "message.vala"
	if (_tmp19_.y > monitor_bottom) {
#line 1380 "message.c"
		GdkRectangle _tmp20_;
		GtkAllocation _tmp21_;
#line 308 "message.vala"
		_tmp20_ = self->priv->m_cursor_location;
#line 308 "message.vala"
		_tmp21_ = allocation;
#line 308 "message.vala"
		y = _tmp20_.y - _tmp21_.height;
#line 1389 "message.c"
	} else {
		GdkPoint _tmp22_;
#line 310 "message.vala"
		_tmp22_ = cursor_left_bottom;
#line 310 "message.vala"
		y = _tmp22_.y;
#line 1396 "message.c"
	}
#line 311 "message.vala"
	if (y < 0) {
#line 312 "message.vala"
		y = 0;
#line 1402 "message.c"
	}
#line 314 "message.vala"
	message_dialog_move (self, x, y);
#line 1406 "message.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 323 "message.vala"
	return self ? g_object_ref (self) : NULL;
#line 1414 "message.c"
}

static void
message_dialog_get_monitor_geometry (MessageDialog* self,
                                     GtkWidget* window,
                                     GdkRectangle* result)
{
	GdkRectangle monitor_area = {0};
	GdkRectangle _tmp0_ = {0};
	GdkMonitor* monitor = NULL;
	GdkDisplay* _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkMonitor* _tmp4_;
	GdkMonitor* _tmp5_;
	GdkRectangle _tmp6_ = {0};
#line 317 "message.vala"
	g_return_if_fail (self != NULL);
#line 317 "message.vala"
	g_return_if_fail (window != NULL);
#line 318 "message.vala"
	_tmp0_.x = 0;
#line 318 "message.vala"
	monitor_area = _tmp0_;
#line 323 "message.vala"
	_tmp1_ = gtk_widget_get_display (window);
#line 323 "message.vala"
	_tmp2_ = self->priv->m_cursor_location;
#line 323 "message.vala"
	_tmp3_ = self->priv->m_cursor_location;
#line 323 "message.vala"
	_tmp4_ = gdk_display_get_monitor_at_point (_tmp1_, _tmp2_.x, _tmp3_.y);
#line 323 "message.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 323 "message.vala"
	monitor = _tmp5_;
#line 326 "message.vala"
	gdk_monitor_get_geometry (monitor, &_tmp6_);
#line 326 "message.vala"
	monitor_area = _tmp6_;
#line 327 "message.vala"
	*result = monitor_area;
#line 327 "message.vala"
	_g_object_unref0 (monitor);
#line 327 "message.vala"
	return;
#line 1461 "message.c"
}

static void
message_dialog_realize_window (MessageDialog* self,
                               gboolean initial)
{
	GdkWindow* window = NULL;
	GtkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GType instance_type = 0UL;
	GdkWindow* _tmp4_;
	GType wayland_type = 0UL;
	void* surface = NULL;
	GdkWindow* _tmp6_;
	void* _tmp7_;
	void* _tmp8_;
#line 331 "message.vala"
	g_return_if_fail (self != NULL);
#line 334 "message.vala"
	if (self->priv->m_no_wayland_panel) {
#line 335 "message.vala"
		return;
#line 1486 "message.c"
	}
#line 336 "message.vala"
	_tmp0_ = self->priv->m_toplevel;
#line 336 "message.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) _tmp0_);
#line 336 "message.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 336 "message.vala"
	window = _tmp2_;
#line 337 "message.vala"
	_tmp3_ = window;
#line 337 "message.vala"
	if (!gdk_window_ensure_native (_tmp3_)) {
#line 338 "message.vala"
		g_warning ("message.vala:338: No native window.");
#line 339 "message.vala"
		_g_object_unref0 (window);
#line 339 "message.vala"
		return;
#line 1506 "message.c"
	}
#line 341 "message.vala"
	_tmp4_ = window;
#line 341 "message.vala"
	instance_type = G_TYPE_FROM_INSTANCE ((GObject*) _tmp4_);
#line 342 "message.vala"
	wayland_type = gdk_wayland_window_get_type ();
#line 343 "message.vala"
	if (!g_type_is_a (instance_type, wayland_type)) {
#line 344 "message.vala"
		g_warning ("message.vala:344: Not GdkWindowWayland.");
#line 345 "message.vala"
		_g_object_unref0 (window);
#line 345 "message.vala"
		return;
#line 1522 "message.c"
	}
#line 347 "message.vala"
	if (initial) {
#line 1526 "message.c"
		GdkWindow* _tmp5_;
#line 348 "message.vala"
		_tmp5_ = window;
#line 348 "message.vala"
		gdk_wayland_window_set_use_custom_surface (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gdk_wayland_window_get_type (), GdkWaylandWindow));
#line 1532 "message.c"
	}
#line 349 "message.vala"
	_tmp6_ = window;
#line 349 "message.vala"
	_tmp7_ = gdk_wayland_window_get_wl_surface (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gdk_wayland_window_get_type (), GdkWaylandWindow));
#line 349 "message.vala"
	surface = _tmp7_;
#line 350 "message.vala"
	_tmp8_ = surface;
#line 350 "message.vala"
	g_signal_emit (self, message_dialog_signals[MESSAGE_DIALOG_REALIZE_SURFACE_SIGNAL], 0, _tmp8_);
#line 331 "message.vala"
	_g_object_unref0 (window);
#line 1546 "message.c"
}

static void
message_dialog_class_init (MessageDialogClass * klass,
                           gpointer klass_data)
{
#line 23 "message.vala"
	message_dialog_parent_class = g_type_class_peek_parent (klass);
#line 23 "message.vala"
	g_type_class_adjust_private_offset (klass, &MessageDialog_private_offset);
#line 23 "message.vala"
	G_OBJECT_CLASS (klass)->finalize = message_dialog_finalize;
#line 23 "message.vala"
	message_dialog_signals[MESSAGE_DIALOG_CLOSE_SIGNAL] = g_signal_new ("close", TYPE_MESSAGE_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "message.vala"
	message_dialog_signals[MESSAGE_DIALOG_REALIZE_SURFACE_SIGNAL] = g_signal_new ("realize-surface", TYPE_MESSAGE_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
#line 1563 "message.c"
}

static void
message_dialog_instance_init (MessageDialog * self,
                              gpointer klass)
{
#line 23 "message.vala"
	self->priv = message_dialog_get_instance_private (self);
#line 1572 "message.c"
}

static void
message_dialog_finalize (GObject * obj)
{
	MessageDialog * self;
#line 23 "message.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MESSAGE_DIALOG, MessageDialog);
#line 24 "message.vala"
	_g_object_unref0 (self->priv->m_toplevel);
#line 25 "message.vala"
	_g_object_unref0 (self->priv->m_vbox);
#line 26 "message.vala"
	_g_object_unref0 (self->priv->m_hbox);
#line 27 "message.vala"
	_g_object_unref0 (self->priv->m_title_label);
#line 28 "message.vala"
	_g_object_unref0 (self->priv->m_description_label);
#line 29 "message.vala"
	_g_object_unref0 (self->priv->m_progress_bar);
#line 30 "message.vala"
	_g_object_unref0 (self->priv->m_progress_label);
#line 31 "message.vala"
	_g_object_unref0 (self->priv->m_timeout_label);
#line 32 "message.vala"
	_g_object_unref0 (self->priv->m_button);
#line 23 "message.vala"
	G_OBJECT_CLASS (message_dialog_parent_class)->finalize (obj);
#line 1601 "message.c"
}

static GType
message_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MessageDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) message_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MessageDialog), 0, (GInstanceInitFunc) message_dialog_instance_init, NULL };
	GType message_dialog_type_id;
	message_dialog_type_id = g_type_register_static (gtk_box_get_type (), "MessageDialog", &g_define_type_info, 0);
	MessageDialog_private_offset = g_type_add_instance_private (message_dialog_type_id, sizeof (MessageDialogPrivate));
	return message_dialog_type_id;
}

GType
message_dialog_get_type (void)
{
	static volatile gsize message_dialog_type_id__once = 0;
	if (g_once_init_enter (&message_dialog_type_id__once)) {
		GType message_dialog_type_id;
		message_dialog_type_id = message_dialog_get_type_once ();
		g_once_init_leave (&message_dialog_type_id__once, message_dialog_type_id);
	}
	return message_dialog_type_id__once;
}

